=== Tests/CTestTestCostSerial/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED (VERSION 2.6)
PROJECT (CTestTestCostSerial)
INCLUDE (CTest)

ADD_EXECUTABLE (Sleep sleep.c)

FOREACH (index RANGE 1 3)
  ADD_TEST (TestSleep${index} Sleep)
ENDFOREACH (index RANGE 1 3)

SET_TESTS_PROPERTIES(TestSleep1 PROPERTIES COST -500)
SET_TESTS_PROPERTIES(TestSleep2 PROPERTIES COST 12)
SET_TESTS_PROPERTIES(TestSleep3 PROPERTIES COST 0)
