=== debian/changelog ===
cmake (2.8.9-1~bpo60+2) squeeze-backports; urgency=low

  * Make tests pass when cmake build path contains regex metacharacters. This
    fixes FTBFS on the BPO buildds.
    Patch: Fix-test-failures-caused-by-regexp-sensitive-charact.patch

 -- Modestas Vainius <modax@debian.org>  Sun, 02 Jun 2013 22:41:48 +0300

cmake (2.8.9-1~bpo60+1) squeeze-backports; urgency=low

  * Rebuild for squeeze-backports.

 -- Modestas Vainius <modax@debian.org>  Sun, 19 May 2013 23:03:09 +0300

cmake (2.8.9-1) unstable; urgency=low

  * New upstream release (no upstream changes since RC3).
  * Make FindPostgreSQL find headers on Debian. Thanks to Pere Nubiola i
    Radigales and Gregor Jasny. (Closes: #665721)
    Patch: FindPostgreSQL_665721.diff
  * Refresh patches.
  * Install to multiarch libdir on kFreeBSD and Hurd like on Linux. Thanks
    to John Stamp (Closes: #684956)
    Patch: install_to_multiarch_libdir_on_kfreebsd_hurd.diff

 -- Modestas Vainius <modax@debian.org>  Sat, 18 Aug 2012 23:13:37 +0300

cmake (2.8.9~rc3-1) unstable; urgency=low

  * New upstream release:
    - fixes COMPONENT option. (Closes: #681428)
  * Remove obsolete /etc/emacs/site-start.d/50cmake.el conffile (predates
    squeeze). (Closes: #681625)

 -- Modestas Vainius <modax@debian.org>  Sat, 04 Aug 2012 10:41:40 +0300

cmake (2.8.9~rc1-1) unstable; urgency=low

  * New upstream release.
  * Remove patches, merged upstream:
    - backport_findpkgconfig_set_found_variable.diff;
    - backport_module_no_soname.diff;
    - manpage_fixes.diff.
  * Drop cmake-{qt,curses}-gui.lintian-overrides, not needed with newer lintian.
  * Enable hardening flags (by appending CPPFLAGS to C(XX)FLAGS).

 -- Modestas Vainius <modax@debian.org>  Wed, 27 Jun 2012 21:34:06 +0300

cmake (2.8.8-3) unstable; urgency=low

  * Backport a no-soname feature from CMake (2.8.9) master tree. Just set a
    NO_SONAME property on the shared library or module target in order to skip
    addition of the SONAME field to the shared object. This makes it possible to
    build Debian Python policy compliant modules with CMake. (Closes: #668982)

 -- Modestas Vainius <modax@debian.org>  Wed, 02 May 2012 21:50:09 +0300

cmake (2.8.8-2) unstable; urgency=low

  * FindPkgConfig.cmake: properly set documented PKG_CONFIG_FOUND variable
    (patch backport_findpkgconfig_set_found_variable.diff). (Closes: #669627)

 -- Modestas Vainius <modax@debian.org>  Sun, 29 Apr 2012 09:55:50 +0300

cmake (2.8.8-1) unstable; urgency=low

  * New upstream release:
    - do not segfault when adding symbols to ZIP. (Closes: #666456)
      Fixed by upstream commit: 768cf9183
  * Remove patches merged/backported from upstream:
    - backport_findpython_fixes.diff
    - backport_findruby_improvements.diff
    - backport_support_cxxtest4.diff
    - manpage_fixes.diff
    - mipsel_is_little_endian.diff
    - paths_in_regex_espace_metachars.diff
  * Refresh FindBoost_add_-lpthread_#563479.diff patch.
  * Readd manpage_fixes.diff patch with new man page fixes.

 -- Modestas Vainius <modax@debian.org>  Thu, 19 Apr 2012 22:32:10 +0300

cmake (2.8.7-4~bpo60+1) squeeze-backports; urgency=low

  * Rebuild for squeeze-backports.

 -- Modestas Vainius <modax@debian.org>  Fri, 30 Mar 2012 20:22:09 +0300

cmake (2.8.7-4) unstable; urgency=low

  * Backport a bunch of FindPython* related commits from cmake master. It
    is now possible to force a specific python version via command line again.
    The interface has changed though, see NEWS entry. (Closes: #663188)
    Patch: backport_findpython_fixes.diff
  * Backport a bunch of FindRuby improvements from cmake master. It should be
    able to properly find ruby 1.9.1 as packaged in Debian now.
    (Closes: #643949)
    Patch: backport_findruby_improvements.diff
  * Add support for CxxTest 4 in FindCxxTest (backport a patch from cmake
    master). (Closes: #662982) Thanks to Simone Rossetto.
    Patch: backport_support_cxxtest4.diff
  * Bump Standards-Version to 3.9.3: no changes needed.
  * Mark cmake Multi-Arch: foreign. The change was stolen from Ubuntu
    cmake_2.8.7-0ubuntu3 package. Thanks to Steve Langasek.

 -- Modestas Vainius <modax@debian.org>  Fri, 16 Mar 2012 23:49:28 +0200

cmake (2.8.7-3) unstable; urgency=medium

  * Fix some tests not to fail if absolute build path contains regex
    metacharacters like +. This makes the package binNMUable again.
    (patch paths_in_regex_espace_metachars.diff)
  * Drop support_cppflags.diff patch because this particular solution was
    rejected by upstream. This reopens #653916.

 -- Modestas Vainius <modax@debian.org>  Mon, 27 Feb 2012 00:56:14 +0200

cmake (2.8.7-2) unstable; urgency=low

  * Properly detect mipsel as little endian architecture. Fixes FTBFS (patch
    mipsel_is_little_endian.diff).
  * Bump debhelper compat level to 9 in order to receive build flags
    automagically.

 -- Modestas Vainius <modax@debian.org>  Sun, 19 Feb 2012 13:44:42 +0200

cmake (2.8.7-1) unstable; urgency=low

  * New upstream release. (Closes: #658427)
  * Disable CTestTestUpload test because it requires Internet access. Thanks to
    Felix Geyer. (Closes: #634603)
  * Remove multiarch_lib_dirs_should_be_implicit.diff patch, merged upstream.
  * Refresh other patches.
  * Respect CPPFLAGS environment variable when building C/C++ sources (patch
    support_cppflags.diff). (Closes: #653916)
  * Fix various typos and formatting errors in manpages (patch
    manpage_fixes.diff).
  * Update install files: add usr/share/aclocal/cmake.m4.

 -- Modestas Vainius <modax@debian.org>  Sat, 18 Feb 2012 15:33:35 +0200
